<?php
/*
Copyright by Arjen van der Meijden, 2001, 2002
acm@vulcanus.its.tudelft.nl

License is simple:
Free for non-commercial use.
For any commercial use, contact the author.

v0.70 Start of numbering
v0.71 Stupid bug that caused close_tags not to work...
*/

require($core->pad.'include/parser_instellingen.inc.php');

function build_tag_reg($tag_array, $end_tag_char)
{
    $num_tags = count($tag_array);
    $tag_reg = '(';
    $keys = array_keys($tag_array);
    if($num_tags > 0);
    {
        $worker = $tag_array[$keys[0]];
        $tag_reg .= $worker[0];
        if($worker[1])
            $tag_reg .= '|' . $end_of_tag . $worker[0];
    
        for($i = 1; $i < $num_tags; $i++)
        {
            $hulp = $keys[$i];
            $tag_array[$hulp][0];
            $tag_reg .= '|' . $tag_array[$hulp][0];
            if($tag_array[$hulp][1] == 1)
            {
                $tag_reg .= '|' . $end_tag_char . $tag_array[$hulp][0];
            }
        }
    }
    $tag_reg .= ')';
    return $tag_reg;
    
}


$tag_stop = "";
$open_stops = 0; 
$stop_simple = 0; // mogen simpele tags wel?

function tag_exists($tag, $allowed_tags, $end_tag_char)
{
    global $tag_stop, $parse_array, $open_stops, $stop_simple;
    $no_stop = false;
    $regexp = "!^{$allowed_tags}(?=(=(.*)|\s(.*))|\$)!i";
    
    $status = preg_match($regexp, $tag, $matches);
    $return_array = array(1);
    
    if(!$status)
    {
        $return_array[0] = 0;
        return $return_array;
    }
    else
    {
        $realtag = strtolower(str_replace($end_tag_char, "", $matches[0]));
        $use_tag = strtolower($matches[0]);
        $return_array = array(1, $realtag, $tag);
        // tag bestaat niet tag_stop is open en dit is niet een stopper of er waren er meerdere open
        if(empty($parse_array[$realtag]) || 
($tag_stop != "" && (($use_tag != $tag_stop && $open_stops > 0) && !($parse_array[$realtag][8] != 0 && !$stop_simple))))
        {
            $return_array = array(0, $tag);
            $type = 0;
        }
        elseif($tag_stop != "" && $use_tag == $tag_stop)
        {
            $open_stops--;
            if($open_stops <= 0)
            {
                $open_stops = 0;
                $tag_stop = "";
                $stop_simple = 0;
            }
            else
            {
                $return_array = array(0);
                $type = 0;
            }
            $no_stop = true;
        }

        if($return_array[0] && $tag[0] == $end_tag_char)
        {
            $return_array = array(2, $realtag, $tag);
        }

        if($parse_array[$realtag][1] && !$no_stop && $parse_array[$realtag][7] && $tag[0] != $end_tag_char && ($tag_stop == "" || $tag_stop == ($end_tag_char . $realtag)))
        {    
            if($tag_stop == "")
            {
                $tag_stop = $end_tag_char . $realtag;
                $stop_simple = $parse_array[$realtag][7] -1;
            }
            $open_stops++;
        }
        return $return_array;    
    }
}

function clean_up_array($input_array)
{
    $output_array = array();
    $count = 0;
    $prev_field = 5;
    foreach($input_array as $input_row)
    {
        if($input_row[1] == "")
        {
            // Do nothing?
        }
        elseif($input_row[0] == 0 && $prev_field == 0)
        {
            $output_array[$count-1][1] .= $input_row[1];
        }
        else
        {
            $count++;
            $output_array[] = $input_row;
            $prev_field = $input_row[0];
        }
    }
    return $output_array;
}

function pre_parse($input_text)
{
    global $pre_parse_find, $pre_parse_replace;
    return preg_replace($pre_parse_find, $pre_parse_replace, $input_text);
}

function split_text($input, $start="\\[", $end="\\]")
{
    global $start_of_tag, $end_of_tag, $parse_array, $end_tag_char;
    
    $tag_reg = build_tag_reg($parse_array, $end_tag_char); // 0.02 secs
    $temp_result = array();
    $start_point = 0;
    $next_point = 0;
    $total_chars = strlen($input);
    // Moving the first strpos() here saves about 0.01 sec ?? Although the number of total strpos() is 2/3 of the original
     
    while($next_point < $total_chars)
    {
        $pos = strpos ($input, $start_of_tag, $start_point);
        if ($pos === false) // nothing found anymore, no need to continue found...
        {
            $next_point = $total_chars;
            $temp_result[] = array(0, substr($input, $start_point, ($next_point - $start_point)));
            break;    
        }
        else
        {
            $next_point = $pos;
            $pos2 = strpos($input, $end_of_tag, $pos+1);
            $pos_hulp = strpos($input, $start_of_tag, $pos+1); //Wel extra check dus wellicht slomer, gelukkig wel "recursief"
            if($pos_hulp !== false && $pos2 !== false && $pos_hulp < $pos2)
            {
                $temp_result[] = array(0, substr($input, $start_point, ($pos_hulp - $start_point)));
                $start_point = $pos_hulp;
            }
            elseif($pos2 === false) // There is no ] left... let's stop
            {
                $temp_result[] = array(0, substr($input, $start_point));
                break;
            }
            else
            {
                // Printable text
                $sub_tekst = substr($input, $start_point, ($next_point - $start_point));
                // Tag
                $tag = substr($input, $pos+1, ($pos2 - $pos-1));
                $tag_type = tag_exists($tag, $tag_reg, $end_tag_char);
                if($tag_type[0] > 0)
                {
                    $temp_result[] = array(0, $sub_tekst);
                    $temp_result[] = $tag_type;
                }
                else
                {
                    $temp_result[] = array(0, $sub_tekst . substr($input, $pos, ($pos2 - $pos+1)));
                }
                $start_point = $pos2+1;
            }
        //$pos = $pos_hulp;
        }
    }
    return $temp_result;
}

/* De daadwerkelijke parse functie...
* Deze gaat proberen de tekst in te voegen
* tot een leesbaar geheel :)
*/
function parse($input_text, $pre_parse=true)
{

$start_of_parse = getmicrotime();

    global $parse_array, $default_function, $start_of_tag, $end_of_tag;
    //prechecks:
    if(trim($input_text) == "")
    {
        return;
    }
    if(isset($pre_parse) && $pre_parse)
    {
    $starttime = getmicrotime();
        $work_text = pre_parse($input_text);
    $endtime = getmicrotime();
    $totaltime = $endtime - $starttime;
    //echo "preparse procedure took: {$totaltime}<br /><br />\n";
    }
    else
    {
        $work_text = $input_text;
    }
    if(strpos($work_text, $start_of_tag) === false)
    {
        return array(html_text($input_text), html_text($input_text));
    }


$starttime = getmicrotime();
    $output_array = split_text($work_text);
$endtime = getmicrotime();
$totaltime = $endtime - $starttime;
//echo "splitting procedure took: {$totaltime}<br /><br />\n";

$starttime = getmicrotime();
    $output_array = clean_up_array($output_array);
$endtime = getmicrotime();
$totaltime = $endtime - $starttime;
//echo "cleaning procedure took: {$totaltime}<br /><br />\n";

    $array_elements = count($output_array);
    $current_tag_array = array();
    $current_tag_index = -1;
    $current_tag = array();
    $expected_end = "";
    $no_end_tag = false;
    $prev_text = "";

    $output_text = "";
    for($i = 0; $i < $array_elements; $i++)
    {
        // hardcoded array interpreteren?? Humm...
        $current_work = $output_array[$i];
        $type_work = $current_work[0];
        if($type_work > 0)
        {
            //Tag
            // - Kijk of het een afsluiter is, zoja, maar niet de goede, echo een error?
            //   sluit de tag dan af en doe current_tag een stapje terug (arraypop?)
            // - Anders verander current_tag naar nieuwe tag (arraypush)
            $tag = $output_array[$i][1];
            $full_tag = $output_array[$i][2];
            
            if($type_work == 2)
            {
                //Afsluiter
                if($tag == $expected_end)
                {
                    $output_text .= $current_tag[6];
                    array_pop($current_tag_array);
                    $tags_in_array = count($current_tag_array);
                    if($tags_in_array > 0)
                    {
                        $prev_tag = $current_tag_array[$tags_in_array - 1];
                        $current_tag = $parse_array[$prev_tag];
                        $expected_end = $current_tag[0];
                    }
                    else
                    {
                        $prev_tag = '';
                        $current_tag = '';
                        //$expected_end = '';
                    }
                    //}
                    //else
                    //{
                    //    $prev_tag = '';
                    //    $current_tag = '';
                    //    $expected_end = '';
                    //}
                }    
                else
                {
                    //echo "<p>Tag was: [{$full_tag}], expected tag was: [/{$expected_end}] -&gt; closing all open tags, closing the [{$tag}] and then reopening all closed tags. Next time, make a better post :P</p>";
                    //Hier komt dus de code om de tag dan alsnog te sluiten
                    //return false;
                    $tekst = close_tags($current_tag_array, $tag, $parse_array);
                    if(!$tekst)
                        $output_text .= $start_of_tag . $full_tag . $end_of_tag;
                    else
                        $output_text .= $tekst; 
                }
            }
            else
            {
                //Nieuwe start
                $temp_tag = $parse_array[$tag];
                if(empty($temp_tag))
                {
                    // No such tag :)
                    //echo "<p>No tag [{$tag}] in stock -&gt; continue parsing, don't expect much good now anymore</p>";
                    $output_text .= "[{$tag}]";
                    $no_end_tag = true;
                }
                else
                {
                    $current_tag = $temp_tag;
                    $output_text .= $current_tag[2] . build_param($current_tag[3], $tag, $full_tag) . $current_tag[4];

                    if($current_tag[1] != 0)
                    {
                        array_push($current_tag_array, $tag);
                        $expected_end = $current_tag[0];
                    }
                    else
                    {
                        //Geen einde tag
                        $tag_count = count($current_tag_array);
                        if($tag_count > 1)
                        {
                            $prev_tag = $current_tag_array[$tag_count-1];
                            $current_tag = $parse_array[$prev_tag];
                        }
                    }
                }
            }                
        }
        else
        {
            //Tekst
            // Voer over deze tekst de functie uit die bij de tag staat
            // Als er geen tag is, dan wordt de default functie uitgevoerd
            $text = $output_array[$i][1];
            if($current_tag)
                $output_text .= build_html($current_tag[5], $text);
            else
                $output_text .= build_html(0, $text);
        }
    }    
    
    $count_tags = count($current_tag_array);
    if($count_tags != 0)
    {
        //echo "<p>Parse error, we have some tags left open, closing all of them now:</p><pre>\n";
        //print_r($current_tag_array);
        //echo "</pre>\n";
        for($i=0; $i < $count_tags; $i++)
        {
            $output_text .= $parse_array[$current_tag_array[$i]][6];
        }
    }
    return array($output_array, $output_text);
}

function close_tags($open_tags, $close_tag, $parse_arr)
{
    if(!in_array($close_tag, $open_tags))
    {
        return;
    }
    else
    {
        $num_tags = count($open_tags);
        $traverse = $num_tags - $key;
        $output_text = "";
        $help_array = array();
        while(($var = array_pop($open_tags)) && $var != $close_tag)
        {
            $output_text .= $parse_arr[$var][6];
            array_push($help_array, $var);
        }
        $output_text .= $parse_arr[$var][6];
        while($var = array_pop($help_array))
        {
            $output_text .= $parse_arr[$var][2];
            array_push($open_tags, $var);
        }
    }
    return $output_text;
}
?>